﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Deleter
{
    class Program
    {

        static void Main( string[] args )
        {
            var appParams = new AppParams();

            if ( appParams.Validate( args ) )
            {
                Console.WriteLine( "working..." );
                new FileMunger( appParams ).Process();
            }
            else
            {
                /// Test:
                /// - c:\temp output:c:\temp\report.txt  -- 150
                /// Should return more than above
                /// - c:\temp output:c:\temp\report.txt cutoff:15  -- 153
                /// Nada:
                /// - c:\temp output:c:\temp\report.txt cutoff:15 guid
                /// 2:
                /// - c:\temp output:c:\temp\report.txt cutoff:1 guid folders
                /// - c:\temp output:c:\temp\report.txt folders
                /// - c:\temp output:c:\temp\report.txt numeric
                /// - c:\temp output:c:\temp\report.txt folders numeric
                /// Should always return nothing:
                /// - c:\temp output:c:\temp\report.txt numeric guid
                Console.WriteLine( appParams.ErrMsg );
                Console.WriteLine( "=======================================================" );
                Console.WriteLine( "Usage: Program.exe SEARCH_DIR [cutoff:N] [output:OUT_PATH] [guid] [folders] [numeric]" );
                Console.WriteLine( "Sample: Program.exe c:\\Junk cutoff:15 output:c:\\SomeDir\\report.txt guid" );
                Console.WriteLine( "-- cutoff: Only objects whose creation date is older than cutoff will be processed" );
                Console.WriteLine( "-- If no cutoff days amount is passed, default is 30 days." );
                Console.WriteLine( "-- If pass no OUT_PATH, matching objects will be deleted; otherwise the OUT_PATH file will be created as a batch file ready for examination and/or execution." );
                Console.WriteLine( "-- If pass \"guid\", only objects whose name is a valid guid (along with date restriction) will be deleted." );
                Console.WriteLine( "-- If pass \"folders\", folder objects will be processed instead of files." );
                Console.WriteLine( "-- If pass \"numeric\", only objects whose name BEGINS with a numeric char will be processed." );
                Console.WriteLine( string.Empty );
            }

            // This holds it in memory forever if running as a scheduled task
            //Console.WriteLine("Don't forget to comment out the next line");
            //Console.ReadLine();
        }
    }
}
